extern   int      extCountBars   = 3000;  //   
extern   double   extHAdd        = 50;    //     
extern   bool     extDrawZigZag  = true;

int      i;
int      mExtrType = 0;
int      handle, mN, mNAbs;
datetime LastPointTime, PointTime,
         MaxTime, MinTime;

double   LastPointPrice,PointPrice,
         MinPrice, MaxPrice, mHAdd,
         mSpresd, mPartRange;
     

int start()  {

   mSpresd = Ask-Bid;
   extCountBars  = MathMin(extCountBars, Bars);

     handle=FileOpen(Symbol()+"_SeekMinPriceDiv.csv",FILE_CSV|FILE_WRITE, '\t');    //Alert(GetLastError()+"--------"+handle);

   for (int l=1; l<=extHAdd; l++)   {
      f_DeleteAllZigZag ();
      mHAdd = l*(Ask-Bid);                                                          //Alert(extCountBars+"  "+DoubleToStr(mHAdd, Digits));
      f_SeekZigZag ();
      WindowRedraw();                                                               //Alert(l+"  "+DoubleToStr(mHAdd, Digits));
   }

   if( handle>0 ) FileClose(handle);

return(0);  }

void f_DrawZigZag()  {
   string   mNameZigZagPart;
   LastPointTime = PointTime; LastPointPrice = PointPrice;
   if ( mExtrType == -1 )  {
      PointTime  = MinTime;   
      PointPrice = MinPrice; 
   }  else {
      PointTime  = MaxTime;   
      PointPrice = MaxPrice; 
   }
   if ( extDrawZigZag && LastPointTime != 0 ) {  
      mNameZigZagPart = "ZZ_"+TimeToStr(Time[i], TIME_DATE | TIME_MINUTES);         //Alert(" "+mNameZigZagPart);
      ObjectDelete(mNameZigZagPart);
      ObjectCreate(mNameZigZagPart,OBJ_TREND, 0, LastPointTime, LastPointPrice, PointTime, PointPrice);
      ObjectSet(mNameZigZagPart,OBJPROP_RAY, false);
      ObjectSet(mNameZigZagPart,OBJPROP_COLOR, Orange);
      ObjectSet(mNameZigZagPart,OBJPROP_WIDTH, 3);
   }
   if( handle>0 && LastPointTime != 0)    {
     mPartRange = PointPrice-LastPointPrice;
     mN = MathRound(mPartRange/mHAdd);
     mNAbs = MathAbs(mN);
     FileWrite(handle, mHAdd, mSpresd, TimeToStr(PointTime), mPartRange, 
     mN, mNAbs, mHAdd*(mNAbs-2)-mSpresd );
   }

}

void f_SeekZigZag () {
   MinPrice = Low[0]; MaxPrice   =  High[0];
   MaxTime = Time[0]; MinTime    = Time[0];

   for ( i = 1; i <= extCountBars; i++)   {        //Alert("Low[i] "+DoubleToStr(Low[i], Digits)+" MaxPrice "+DoubleToStr(MaxPrice, Digits)+" MinPrice "+DoubleToStr(MinPrice, Digits)+" High[i] "+DoubleToStr(High[i], Digits) );

      if ( //MathAbs(Low[i]-MaxPrice) > MathAbs(MinPrice-High[i] ) && 
            MaxPrice - Low[i]   >  mHAdd && mExtrType !=  1
            && High[i] < MaxPrice - Point                                        // - Point -      
            ) {
         mExtrType = 1;    MinPrice = Low [i];  MinTime = Time[i]; i++;          //Alert(" ");
         f_DrawZigZag();
      }
      if ( //MathAbs(Low[i]-MaxPrice) < MathAbs(MinPrice-High[i] ) && 
            High[i]   - MinPrice > mHAdd && mExtrType != -1
            && Low[i] > MinPrice + Point                                         // + Point -      
            ) {
         mExtrType = -1;   MaxPrice = High[i]; MaxTime = Time[i]; i++;           //Alert(" ");
         f_DrawZigZag();
      }

      if ( High[i] >= MaxPrice && mExtrType ==  -1 ) { MaxPrice = High[i]; MaxTime = Time[i];   }
      if ( Low[i]  <= MinPrice && mExtrType ==   1 ) { MinPrice = Low [i]; MinTime = Time[i];   }

   }
}

void f_DeleteAllZigZag ()  {
   int mComPoint = ObjectsTotal();
   for ( int iCounter=0; iCounter<mComPoint; iCounter++) {
      if ( ObjectName(iCounter) != "" )   {
         if ( StringSubstr(ObjectName(iCounter), 0, 3) == "ZZ_" ) {
            ObjectDelete(ObjectName(iCounter));
            if ( ObjectsTotal() > 1 ) iCounter--;
         }

      }
   }
}